# remirepo/Fedora spec file for php-zendframework-zend-servicemanager-di
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    b9a62f219f9156b1f4b14e131918c7e1f468107b
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-servicemanager-di
%global php_home     %{_datadir}/php
%global library      Di
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.2.0
Release:        4%{?dist}
Summary:        Zend Framework ServiceManager-%{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires: (php-composer(container-interop/container-interop) >= 1.1   with php-composer(container-interop/container-interop) < 2)
BuildRequires: (php-autoloader(%{gh_owner}/zend-di)               >= 2.6   with php-autoloader(%{gh_owner}/zend-di)               < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager)   >= 3.0.3 with php-autoloader(%{gh_owner}/zend-servicemanager)   < 4)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "container-interop/container-interop": "^1.1",
#        "zendframework/zend-di": "^2.6",
#        "zendframework/zend-servicemanager": "^3.0.3"
Requires:       php(language) >= 5.6
Requires:      (php-composer(container-interop/container-interop) >= 1.1   with php-composer(container-interop/container-interop) < 2)
Requires:      (php-autoloader(%{gh_owner}/zend-di)               >= 2.6   with php-autoloader(%{gh_owner}/zend-di)               < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-servicemanager)   >= 3.0.3 with php-autoloader(%{gh_owner}/zend-servicemanager)   < 4)
# From phpcompatinfo report for version 1.1.0
Requires:       php-spl
# Autoloader
Requires:       php-composer(fedora/autoloader)

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Provides integration for zend-di within zend-servicemanager.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE

%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
require_once '%{php_home}/Interop/Container/autoload.php';
EOF

: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Interop/Container/autoload.php',
    '%{php_home}/Zend/Di/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/ServiceManager
cp -pr src %{buildroot}%{php_home}/Zend/ServiceManager/%{library}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/ServiceManager-%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/ServiceManager/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\ServiceManager\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php56 %{_bindir}/phpunit" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/ServiceManager/%{library}
%{php_home}/Zend/ServiceManager-%{library}-autoload.php


%changelog
* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 1.2.0-1
- update to 1.2.0
- use range dependencies on F27+
- switch to phpunit6 or phpunit7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Dec  6 2017 Remi Collet <remi@remirepo.net> - 1.1.1-2
- switch from zend-loader to fedora/autoloader

* Fri Sep 29 2017 Remi Collet <remi@remirepo.net> - 1.1.1-1
- Update to 1.1.1

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 1.1.0-1
- update to 1.1.0 for ZendFramework 3

* Sun Jun 12 2016 Remi Collet <remi@fedoraproject.org> - 1.0.1-1
- initial package

